function [Enrg,E2dd,E2aa,E2ad]= dEnrgdD0dA0(D0A0,efrkd,cparams,data)
% Computes Energy for a given set of measurements and a single D0,A0 pair

D0= D0A0(1); A0= D0A0(2);
Efr= efrkd(1); Kd= 10.^efrkd(2);
a11= cparams(1,1); a12= cparams(1,2); a13= cparams(1,3);
a21= cparams(2,1); a22= cparams(2,2); a23= cparams(2,3);
a31= cparams(3,1); a32= cparams(3,2); a33= cparams(3,3);
n= length(data(1).ydata(:,1));

h1= a11; h2= a12; h3= a11*(1-Efr)+a12+a13*Efr;
h4= a21; h5= a22; h6= a21*(1-Efr)+a22+a23*Efr;
h7= a31; h8= a32; h9= a31*(1-Efr)+a32+a33*Efr;
sub2= sqrt(-4*A0*D0+(A0+D0+Kd)^2);
data_d= data.ydata(:,1);
data_a= data.ydata(:,2);
data_f= data.ydata(:,3);
s1= data.sigdat(1); s2= data.sigdat(2); s3= data.sigdat(3);

if nargout==1
    Enrg= -(-n.*log(s1) - n.*log(s2) - n.*log(s3) -  ...
        sum((-(h6.*(A0 + D0 + Kd - sub2))./2 - h5.*(A0 + (-A0 - D0 - Kd + sub2)./ ...
        2) - h4.*(D0 + (-A0 - D0 - Kd + sub2)./2) + data_a).^2./s2.^2) - ...
        sum((-(h3.*(A0 + D0 + Kd - sub2))./2 - h2.*(A0 + (-A0 - D0 - Kd + sub2)./ ...
        2) - h1.*(D0 + (-A0 - D0 - Kd + sub2)./2) + data_d).^2./s1.^2) - ...
        sum((-(h9.*(A0 + D0 + Kd - sub2))./2 - h8.*(A0 + (-A0 - D0 - Kd + sub2)./ ...
        2) - h7.*(D0 + (-A0 - D0 - Kd + sub2)./2) + data_f).^2./s3.^2));
end

if nargout==4
    Enrg= 0;
    s1= data.sigdat(1); s2= data.sigdat(2); s3= data.sigdat(3);
    sub22= -4*A0*D0+(A0+D0+Kd)^2; %just a substitution to shorten code
    E2dd= sum(((-(A0.*(h4 + h5 - h6)) + D0.*(h4 + h5 - h6) + h4.*Kd +  ...
        h5.*Kd - h6.*Kd + h4.*sqrt(sub22) - h5.*sqrt(sub22) +  ...
        h6.*sqrt(sub22)).^2.*sqrt(sub22) +  ...
        (h4 + h5 - h6).*(A0.^2 + D0.^2 + 2.*D0.*Kd + Kd.^2 - 2.*A0.*(D0 + Kd) -  ...
        sub22).*(-(D0.*h4) + D0.*h5 + A0.*(h4 - h5 - h6) - D0.*h6 + h4.*Kd +  ...
        h5.*Kd - h6.*Kd - h4.*sqrt(sub22) - h5.*sqrt(sub22) +  ...
        h6.*sqrt(sub22) + 2.*data_a))./(2.*s2.^2.*sub22.^(3./2))) +  ...
        sum(((-(A0.*(h1 + h2 - h3)) + D0.*(h1 + h2 - h3) + h1.*Kd + h2.*Kd -  ...
        h3.*Kd + h1.*sqrt(sub22) - h2.*sqrt(sub22) + h3.*sqrt(sub22)).^2.* ...
        sqrt(sub22) + (h1 + h2 - h3).* ...
        (A0.^2 + D0.^2 + 2.*D0.*Kd + Kd.^2 - 2.*A0.*(D0 + Kd) - sub22).* ...
        (-(D0.*h1) + D0.*h2 + A0.*(h1 - h2 - h3) - D0.*h3 + h1.*Kd + h2.*Kd -  ...
        h3.*Kd - h1.*sqrt(sub22) - h2.*sqrt(sub22) + h3.*sqrt(sub22) + 2.*data_d) ...
        )./(2.*s1.^2.*sub22.^(3./2))) +  ...
        sum(((-(A0.*(h7 + h8 - h9)) + D0.*(h7 + h8 - h9) + h7.*Kd + h8.*Kd -  ...
        h9.*Kd + h7.*sqrt(sub22) - h8.*sqrt(sub22) + h9.*sqrt(sub22)).^2.* ...
        sqrt(sub22) + (h7 + h8 - h9).* ...
        (A0.^2 + D0.^2 + 2.*D0.*Kd + Kd.^2 - 2.*A0.*(D0 + Kd) - sub22).* ...
        (-(D0.*h7) + D0.*h8 + A0.*(h7 - h8 - h9) - D0.*h9 + h7.*Kd + h8.*Kd -  ...
        h9.*Kd - h7.*sqrt(sub22) - h8.*sqrt(sub22) + h9.*sqrt(sub22) + 2.*data_f))./ ...
        (2.*s3.^2.*sub22.^(3./2)));
    
    E2aa= sum(((A0.*(h4 + h5 - h6) - D0.*(h4 + h5 - h6) + h4.*Kd + h5.*Kd -  ...
        h6.*Kd - h4.*sqrt(sub22) + h5.*sqrt(sub22) + h6.*sqrt(sub22)).^2.* ...
        sqrt(sub22) + (h4 + h5 - h6).* ...
        (A0.^2 - 2.*A0.*D0 + D0.^2 + 2.*A0.*Kd - 2.*D0.*Kd + Kd.^2 - sub22).* ...
        (-(D0.*h4) + D0.*h5 + A0.*(h4 - h5 - h6) - D0.*h6 + h4.*Kd + h5.*Kd -  ...
        h6.*Kd - h4.*sqrt(sub22) - h5.*sqrt(sub22) + h6.*sqrt(sub22) + 2.*data_a ...
        ))./(2.*s2.^2.*sub22.^(3./2))) + sum(((A0.*(h1 + h2 - h3) - D0.*(h1 + h2 - h3) + h1.*Kd + h2.*Kd -  ...
        h3.*Kd - h1.*sqrt(sub22) + h2.*sqrt(sub22) + h3.*sqrt(sub22)).^2.* ...
        sqrt(sub22) + (h1 + h2 - h3).* ...
        (A0.^2 - 2.*A0.*D0 + D0.^2 + 2.*A0.*Kd - 2.*D0.*Kd + Kd.^2 - sub22).* ...
        (-(D0.*h1) + D0.*h2 + A0.*(h1 - h2 - h3) - D0.*h3 + h1.*Kd + h2.*Kd -  ...
        h3.*Kd - h1.*sqrt(sub22) - h2.*sqrt(sub22) + h3.*sqrt(sub22) + 2.*data_d) ...
        )./(2.*s1.^2.*sub22.^(3./2))) + sum(((A0.*(h7 + h8 - h9) - D0.*(h7 + h8 - h9) + h7.*Kd + h8.*Kd -  ...
        h9.*Kd - h7.*sqrt(sub22) + h8.*sqrt(sub22) + h9.*sqrt(sub22)).^2.* ...
        sqrt(sub22) + (h7 + h8 - h9).* ...
        (A0.^2 - 2.*A0.*D0 + D0.^2 + 2.*A0.*Kd - 2.*D0.*Kd + Kd.^2 - sub22).* ...
        (-(D0.*h7) + D0.*h8 + A0.*(h7 - h8 - h9) - D0.*h9 + h7.*Kd + h8.*Kd -  ...
        h9.*Kd - h7.*sqrt(sub22) - h8.*sqrt(sub22) + h9.*sqrt(sub22) + 2.*data_f))./ ...
        (2.*s3.^2.*sub22.^(3./2)));
    
    E2ad= sum((2.*(-(((h4 + h5 - h6).*(A0 - D0 - Kd) -  ...
        (h4 - h5 + h6).*sqrt(sub22)).* ...
        ((h4 + h5 - h6).*(A0 - D0 + Kd) +  ...
        (-h4 + h5 + h6).*sqrt(sub22)))./(4.*sub22) -  ...
        ((h4 + h5 - h6).*(-(A0 - D0).^2 + Kd.^2 + sub22).* ...
        (D0.*(h4 - h5 + h6) + A0.*(-h4 + h5 + h6) -  ...
        (h4 + h5 - h6).*(Kd - sqrt(sub22)) - 2.*data_a))./(4.*sub22.^(3./2)) ...
        ))./s2.^2) + sum((2.*(-(((h1 + h2 - h3).*(A0 - D0 - Kd) -  ...
        (h1 - h2 + h3).*sqrt(sub22)).* ...
        ((h1 + h2 - h3).*(A0 - D0 + Kd) +  ...
        (-h1 + h2 + h3).*sqrt(sub22)))./(4.*sub22) -  ...
        ((h1 + h2 - h3).*(-(A0 - D0).^2 + Kd.^2 + sub22).* ...
        (D0.*(h1 - h2 + h3) + A0.*(-h1 + h2 + h3) -  ...
        (h1 + h2 - h3).*(Kd - sqrt(sub22)) - 2.*data_d))./(4.*sub22.^(3./2))) ...
        )./s1.^2) + sum((2.*(-(((h7 + h8 - h9).*(A0 - D0 - Kd) -  ...
        (h7 - h8 + h9).*sqrt(sub22)).* ...
        ((h7 + h8 - h9).*(A0 - D0 + Kd) + (-h7 + h8 + h9).*sqrt(sub22)) ...
        )./(4.*sub22) - ((h7 + h8 - h9).*(-(A0 - D0).^2 + Kd.^2 + sub22).* ...
        (D0.*(h7 - h8 + h9) + A0.*(-h7 + h8 + h9) -  ...
        (h7 + h8 - h9).*(Kd - sqrt(sub22)) - 2.*data_f))./(4.*sub22.^(3./2))))./ ...
        s3.^2);
    
end

